
// Vk3DVision (http://3dsurroundgaming.com/) - Original Shader
#version 450
#extension GL_EXT_nonuniform_qualifier : require
#extension GL_ARB_shader_draw_parameters : require
#extension GL_ARB_shader_ballot : require

out float gl_ClipDistance[1];

invariant gl_Position;

struct S_MATRICES
{
    mat4 _mModelViewProj;
    mat4 _mModelViewProjPrevious;
    mat4 _mModelView;
    mat4 _mInvModelView;
};

struct unaligned_float3
{
    float x;
    float y;
    float z;
};

struct S_TBN
{
    int _iNormal;
    int _iTangent;
};

struct S_INDICES
{
    uint _uiObjectIndex;
    uint _uiMaterialIndex;
    uint _uiMaterialInstanceIndex;
    uint _uiLastFrameMaterialIndex;
    uint _uiLastFrameMaterialInstanceIndex;
    uint _uiPositionsBufferIndex;
    uint _uiPrevPositionsBufferIndex;
    uint _uiNormalsBufferIndex;
    uint _uiPositionOffset;
    uint _uiPrevPositionOffset;
    uint _uiNormalOffset;
    uint _uiMatricesIndex;
};

struct S_MAIN_DEFAULT
{
    S_INDICES _Indices;
};

struct S_MAIN_DEFAULT_ARRAY
{
    S_MAIN_DEFAULT _aMain[32];
};

struct S_MESH_OBJECT
{
    mat4 _mModel;
    mat4 _mModelLast;
    mat4 _mInvModel;
    mat4 _mInvModelLast;
    vec4 _vDiversityOffset;
    uint _uiSceneZoneIndex;
    uint _uiNeighborSceneZoneIndex;
    uint _uiDisplayFlags;
    uint _uiPackedLocalExposureCompensation;
    vec4 _vPortalDirAndDistance;
    int _iPickingID[2];
    float _fLocalExposureCompensation;
    float _fLocalExposureCompensationEV100;
};

struct S_MATERIAL
{
    vec4 _vErrorColor;
    float _fDepthBias;
    float _fDummy0;
    float _fDummy1;
    float _fDummy2;
    float c0;
    float c1;
    float c2;
    float c3;
    uint s0;
    uint s1;
    uint s2;
    uint s3;
    uint s4;
    uint s5;
    uint s6;
    uint s7;
    uint s8;
    uint s9;
    uint s10;
    uint s11;
    uint s12;
    uint s13;
    uint s14;
    uint s15;
    uint s16;
    uint s17;
    uint s18;
    uint s19;
};

struct S_MATERIAL_INSTANCE
{
    float c0;
    float c1;
    float c2;
    float c3;
    float c4;
    float c5;
    float c6;
    float c7;
    float _fGloubiboulga;
};

struct S_PASS_MATRICES
{
    mat4 _mViewJitteredProj;
    mat4 _mViewProj;
    mat4 _mView;
    mat4 _mInvView;
    mat4 _mJitteredProj;
};

struct S_EYE_DATA
{
    S_PASS_MATRICES _mCurrentFrameMatrices[2];
    S_PASS_MATRICES _mPreviousFrameMatrices[2];
    mat4 _mJitteredProjection[2];
    mat4 _mNoJitterProjection[2];
    mat4 _mInvViewJitteredProj[2];
    vec4 _vWorldSpaceCameraVector[2];
    vec4 _vWorldSpaceCameraPosition[2];
    vec4 _vFrameBufferScale;
    vec4 _vFrameBufferViewportSize;
    vec4 _vFrameBufferOneOnViewportSize;
    vec4 _vViewportSize;
    vec4 _vFogSubCrop;
    uint _uiAlignment0;
    uint _uiAlignment1;
    float _vCameraJitterDeltaX;
    float _vCameraJitterDeltaY;
    vec4 _vfRcpFVolumetricFogDepthTileSize;
};

struct S_CASCADED_SHADOW
{
    mat4 _mCascadeMatrix[2][8];
    mat4 _mViewSpaceToStaticShadowMapSpace[2];
    vec4 _vfCascadeShadowAttenuation;
    vec4 _vfShadowCascadeTextureTexelSize;
    vec4 _vfStaticShadowBlurRadius;
    vec4 _vfCascadeLinearZProjFactors[8];
    vec4 _vfCascadeParams[8];
};

struct S_CLUSTER_LIGHT_SETUP
{
    S_CASCADED_SHADOW _CascadedShadow;
    vec4 _vfSkinUVParamsAndNormalBias;
    vec4 _vfShadowTextureTexelSize;
    vec4 _vfDummy_SkinFresnelF0AndF90;
    uint _uiCascadedUsed;
    float _fSSSWidth;
    float _fOffsetBias;
    float _fDummy;
};

struct S_CLUSTER_INFO
{
    mat4 _mViewToClusterView[2];
    mat4 _mClusterProjMatrix;
    mat4 _mClusterInvProjMatrix;
    vec4 _vfLeftEyeToCombinedEyeVsDeltaXZ;
    uint _uiFinestMipWidth;
    uint _uiFinestMipHeight;
    uint _uiFinestMipDepth;
    uint _uiFinestMipWidthHeight;
    float _fZSliceGeomFactor;
    float _fRcpLogZSliceGeomFactor;
    float _fDummy0;
    float _fDummy1;
    float _fNearP;
    float _fInvNearP;
    float _fFarP;
    float _fClusterCoincidentWithCamera;
};

struct S_PASS
{
    S_EYE_DATA _EyeData;
    vec4 _avFrustumCorners[4];
    vec4 _vTime;
    vec4 _cFogColor;
    vec4 _vFogSetup;
    vec4 _cSunColor;
    vec4 _vSunDir;
    vec4 _vProjectionSetup;
    vec4 _vProjectionCoeff;
    vec4 _vOutputColor;
    vec4 _vfVsClippingPlane[2];
    S_CLUSTER_LIGHT_SETUP _LightSetup;
    S_CLUSTER_INFO _ClusterInfo;
    float _fIBLIntensity;
    float _fGIIntensity;
    float _fAmbiantOcclusionDirectIntensity;
    float _fAmbiantOcclusionIndirectIntensity;
    float _fNormalSign;
    int _iFogType;
    float _fSelfOcclusionDebugRatio;
    float _fEmissive;
    int _iEnableSkinSSSSS;
    int _iUseHairOpaquePrepass;
    float _fLocalSceneExposure;
    uint _uiDebugMode;
    uint _sFlags;
    float _fTAADropsSharpness;
    uint _uNeoScaleX;
    uint _uNeoScaleY;
    uint _uiDirectOverdrawFilter;
    float _fCoderTest0;
    float _fCoderTest1;
    float _fCoderTest2;
    uint _uiBakeOutput;
    float _fDefaultAmbientIntensity;
    float _fDefaultLightingIntensity;
    uint _uiOutputColor;
    float _fAARotation;
    float _fClampDirectSpecular;
    float _fNearPlane;
    float _fFarPlane;
    float _fNDFFilteringScreenSpaceVariance;
    float _fNDFFilteringThreshold;
    float _fNDFFilteringScreenSpaceVariance_EyeShader;
    float _fNDFFilteringThreshold_EyeShader;
    float _fSurfaceGradientTextureFiltering;
    float _fZero;
    uint _uDepthClamp;
    uint _uiLightDebugMode;
    vec4 _vfFragCoordToDepthTexFactor;
    vec4 _vfFragCoordToDepthTexFactor_HalfRes;
    uint _uHdr;
    uint _uiDrawMayaSwatch;
    float _fEyeRoughnessBias;
    float _fDummy1;
};

layout(set = 1, binding = 24, std430) readonly buffer stc_g_rbMatrices_Layout
{
    S_MATRICES g_rbMatrices[];
} _165;

layout(set = 1, binding = 39, std430) readonly buffer g_rbVertices_Layout
{
    unaligned_float3 g_rbVertices[];
} g_rbVertices_Buffer[];

layout(set = 1, binding = 40, std430) readonly buffer g_rbTBNs_Layout
{
    S_TBN g_rbTBNs[];
} g_rbTBNs_Buffer[];

layout(set = 0, binding = 52, std140) uniform dyn_CONSTANT_BUFFER_BLOCK_CB_S_MAIN_ARRAY_BINDING
{
    S_MAIN_DEFAULT_ARRAY g_cbMainArray;
} _1143;

layout(set = 1, binding = 33, std430) readonly buffer g_rbObjects_Layout
{
    S_MESH_OBJECT g_rbObjects[];
} g_rbObjects_Buffer[];

layout(set = 1, binding = 34, std430) readonly buffer g_rbMaterials_Layout
{
    S_MATERIAL g_rbMaterials[];
} g_rbMaterials_Buffer[];

layout(set = 1, binding = 35, std430) readonly buffer g_rbMaterialInstances_Layout
{
    S_MATERIAL_INSTANCE g_rbMaterialInstances[];
} g_rbMaterialInstances_Buffer[];

layout(set = 2, binding = 53, std140) uniform dyn_CONSTANT_BUFFER_BLOCK_CB_S_PASS_BINDING
{
    S_PASS g_cbPass;
} _1439;

layout(set = 1, binding = 12) uniform sampler2D g_rb2DTextures[];

layout(location = 8) in vec2 in_uv0;
layout(location = 23) out float interp_instanceID;

vec3 _8115;

void main()
{
    int _1133 = gl_InstanceIndex + gl_DrawIDARB;
    int _1134 = readFirstInvocationARB(_1133);
    uint _3097 = uint(gl_VertexIndex);
    uint _3100 = _3097 + _1143.g_cbMainArray._aMain[_1134]._Indices._uiPositionOffset;
    vec4 _3113 = vec4(g_rbVertices_Buffer[_1143.g_cbMainArray._aMain[_1134]._Indices._uiPositionsBufferIndex].g_rbVertices[_3100].x, g_rbVertices_Buffer[_1143.g_cbMainArray._aMain[_1134]._Indices._uiPositionsBufferIndex].g_rbVertices[_3100].y, g_rbVertices_Buffer[_1143.g_cbMainArray._aMain[_1134]._Indices._uiPositionsBufferIndex].g_rbVertices[_3100].z, 1.0);
    uint _3120 = _3097 + _1143.g_cbMainArray._aMain[_1134]._Indices._uiNormalOffset;
    int _3149 = g_rbTBNs_Buffer[_1143.g_cbMainArray._aMain[_1134]._Indices._uiNormalsBufferIndex].g_rbTBNs[_3120]._iNormal & 1023;
    int _3152 = (g_rbTBNs_Buffer[_1143.g_cbMainArray._aMain[_1134]._Indices._uiNormalsBufferIndex].g_rbTBNs[_3120]._iNormal >> 10) & 1023;
    int _3155 = (g_rbTBNs_Buffer[_1143.g_cbMainArray._aMain[_1134]._Indices._uiNormalsBufferIndex].g_rbTBNs[_3120]._iNormal >> 20) & 1023;
    int _8102;
    if (_3149 > 512)
    {
        _8102 = _3149 | (-1024);
    }
    else
    {
        _8102 = _3149;
    }
    int _8104;
    if (_3152 > 512)
    {
        _8104 = _3152 | (-1024);
    }
    else
    {
        _8104 = _3152;
    }
    int _8106;
    if (_3155 > 512)
    {
        _8106 = _3155 | (-1024);
    }
    else
    {
        _8106 = _3155;
    }
    float _3198 = float(_8102);
    float _3201 = float(_8104);
    float _3204 = float(_8106);
    vec3 _3205 = vec3(_3198, _3201, _3204);
    vec3 _3208 = _3205 * vec3(0.001956947147846221923828125);
    vec3 _3298 = _3113.xyz;
    mat3 _3490 = mat3(g_rbObjects_Buffer[_1143.g_cbMainArray._aMain[_1134]._Indices._uiObjectIndex].g_rbObjects[0]._mModel[0].xyz, g_rbObjects_Buffer[_1143.g_cbMainArray._aMain[_1134]._Indices._uiObjectIndex].g_rbObjects[0]._mModel[1].xyz, g_rbObjects_Buffer[_1143.g_cbMainArray._aMain[_1134]._Indices._uiObjectIndex].g_rbObjects[0]._mModel[2].xyz);
    vec3 _3493 = _3490 * _3208;
    vec2 _3718 = in_uv0 * vec2(3.0);
    vec3 _8048 = _8115;
    _8048.y = textureLod(g_rb2DTextures[g_rbMaterials_Buffer[_1143.g_cbMainArray._aMain[_1134]._Indices._uiMaterialIndex].g_rbMaterials[0].s0], _3718, 0.0).x;
    vec3 _3736 = vec3(g_rbMaterialInstances_Buffer[_1143.g_cbMainArray._aMain[_1134]._Indices._uiMaterialInstanceIndex].g_rbMaterialInstances[0].c0);
    vec3 _3739 = mod(_3736, vec3(2.0));
    vec3 _3743 = _8048 * _3739;
    vec3 _8057 = _8115;
    _8057.y = textureLod(g_rb2DTextures[g_rbMaterials_Buffer[_1143.g_cbMainArray._aMain[_1134]._Indices._uiMaterialIndex].g_rbMaterials[0].s0], _3718 + vec2(-0.20000000298023223876953125, -2.099999904632568359375), 0.0).y;
    vec3 _3773 = _3736 * vec3(0.100000001490116119384765625);
    vec3 _3776 = floor(_3773);
    vec3 _3780 = mod(_3776, vec3(2.0));
    vec3 _3784 = _8057 * _3780;
    vec3 _3788 = vec3(1.0) - _3743;
    vec3 _3791 = vec3(1.0) - _3784;
    vec3 _3792 = _3788 * _3791;
    vec3 _8066 = _8115;
    _8066.y = textureLod(g_rb2DTextures[g_rbMaterials_Buffer[_1143.g_cbMainArray._aMain[_1134]._Indices._uiMaterialIndex].g_rbMaterials[0].s0], (in_uv0 * vec2(-2.5, 2.5)) + vec2(0.875, -0.20000000298023223876953125), 0.0).z;
    vec3 _3824 = _3736 * vec3(0.00999999977648258209228515625);
    vec3 _3827 = floor(_3824);
    vec3 _3831 = mod(_3827, vec3(2.0));
    vec3 _3835 = _8066 * _3831;
    vec3 _3842 = vec3(1.0) - _3835;
    vec3 _3843 = _3792 * _3842;
    vec3 _3845 = vec3(1.0) - _3843;
    float _3847 = _3845.y;
    float _3852 = _3847 - 0.949999988079071044921875;
    float _3857 = _3852 * 19.9959964752197265625;
    float _3858 = clamp(_3857, 0.0, 1.0);
    float _3859 = mix(0.0, 1.0, _3858);
    float _3867 = _3847 - 0.88999998569488525390625;
    float _3872 = _3867 * 99.90019989013671875;
    float _3873 = clamp(_3872, 0.0, 1.0);
    float _3874 = mix(0.0, 1.0, _3873);
    vec3 _3879 = vec3(_3874);
    vec3 _3880 = mix(vec3(0.0), vec3(-0.011610000394284725189208984375), _3879);
    vec3 _3885 = vec3(_3859);
    vec3 _3886 = mix(_3880, vec3(-0.03869999945163726806640625), _3885);
    vec3 _3892 = _3886 * _3493;
    vec3 _3900 = vec3(g_rbMaterialInstances_Buffer[_1143.g_cbMainArray._aMain[_1134]._Indices._uiMaterialInstanceIndex].g_rbMaterialInstances[0].c1);
    vec3 _3901 = mix(vec3(0.0), _3892, _3900);
    vec3 _3925 = _3298 + _3901;
    float _4051 = _3925.x;
    float _4052 = _3925.y;
    float _4053 = _3925.z;
    vec4 _4054 = vec4(_4051, _4052, _4053, 1.0);
    vec4 _4055 = _165.g_rbMatrices[_1143.g_cbMainArray._aMain[_1134]._Indices._uiMatricesIndex]._mModelView * _4054;
    vec4 _4074 = _165.g_rbMatrices[_1143.g_cbMainArray._aMain[_1134]._Indices._uiMatricesIndex]._mModelViewProj * _4054;
    vec4 _8112;
    if (_1439.g_cbPass._uDepthClamp == 4294967295u)
    {
        float _4108 = _4074.w;
        vec4 _8113;
        if ((_4074.z / _4108) > 1.0)
        {
            vec4 _8114;
            if (_4055.z > _1439.g_cbPass._fNearPlane)
            {
                vec4 _8079 = _4074;
                _8079.z = _4108;
                _8114 = _8079;
            }
            else
            {
                _8114 = _4074;
            }
            _8113 = _8114;
        }
        else
        {
            _8113 = _4074;
        }
        _8112 = _8113;
    }
    else
    {
        _8112 = _4074;
    }
    interp_instanceID = float(_1133) + 0.5;
    float _2983 = _4055.x;
    float _2984 = _4055.y;
    float _2985 = _4055.z;
    vec4 _2986 = vec4(_2983, _2984, _2985, 1.0);
    float _2987 = dot(_1439.g_cbPass._vfVsClippingPlane[0], _2986);
    float _2988 = -_2987;
    gl_ClipDistance[0] = _2988;
    gl_Position = _8112;
}

